Subject: Re: [PATCH net-next v2] net: sysfs: also pass network device driver to uevent

From: Jakub Kicinski <[email-masked]>
Date: Mon, 18 Nov 2024 17:55:43 -0800

On Sat, 16 Nov 2024 17:30:30 +0100 Til Kaiser wrote:
> Currently, for uevent, the interface name and
> index are passed via shell variables.
> 
> This commit also passes the network device
> driver as a shell variable to uevent.
> 
> One way to retrieve a network interface's driver
> name is to resolve its sysfs device/driver symlink
> and then substitute leading directory components.
> 
> You could implement this yourself (e.g., like udev from
> systemd does) or with Linux tools by using a combination
> of readlink and shell substitution or basename.
> 
> The advantages of passing the driver directly through uevent are:
>  - Linux distributions don't need to implement additional code
>    to retrieve the driver when, e.g., interface events happen.
>  - There is no need to create additional process forks in shell
>    scripts for readlink or basename.
>  - If a user wants to check his network interface's driver on the
>    command line, he can directly read it from the sysfs uevent file.

Thanks for the info, since you're working on an open source project 
- I assume your exact use case is not secret, could you spell it 
out directly? What device naming are you trying to achieve based on
what device drivers? In my naive view we have 200+ Ethernet drivers 
so listing Ethernet is not scalable. I'm curious what you're matching,
how many drivers you need to list, and whether we could instead add a
more general attribute...

Those questions aside, I'd like to get an ack from core driver experts
like GregKH on this. IDK what (if any) rules there are on uevents.
The merge window has started so we are very unlikely to hear from them
now, all maintainers will be very busy. Please repost v3 in >=two weeks
and CC Greg (and whoever else is reviewing driver core and/or uevent
changes according to git logs).
-- 
pw-bot: defer